
N=14;
l=0.5;
o=l*0.36; % Overflateareal til kjttblokkene

dy=0.01; %
Ny=round(0.07/dy); % antall dybdesteg

dx=0.1;
Nx=round(2/dx); % antall breddesteg

v=0.4/60;

dk=dx/v; % tidsteg [sek/steg]
Nk=300/dk + N  ; % antall tidssteg


Tarr  =  zeros(Ny,Nx+1,Nk+1); % lager temperatur matrise
T     =  zeros(Ny,Nx+1);

%% SS Definerer Tny for  lagre ny T i
Tnew = zeros(Ny,Nx+1);
T_a  = 10; % omgivelses temperatur

isMeat    = zeros(1,Nx+1);
meat      = zeros(1,Nk+1);
isMeatNew = zeros(1,Nx+1);   %% SS Ny variabel
fatNew    = zeros(1,Nx+1);   %% SS Ny variabel

Q=zeros(Nx,Ny); % energi matrise
Q_under=zeros(Nx,Ny);
% q1=1/2;
% q2=1/2;

r=dk/dy^2;

F=zeros(1,Nk+1); % fettprosent i kjttet
fat=zeros(1,Nx+1);



p=1057; % tetthet kg/m^3

h=5; % varmeovergangstall mellom kjtt og luft W/m^2K

%% SS Setter inn kjttstripe for k=1 og k=5
meat(1) = 1;
F(1)=5;
meat(2)=1;
F(2)=5;
meat(3) = 1;
F(3)=5;
meat(4)=1;
F(4)=5;
meat(5) = 1;
F(5)=5;
meat(6)=1;
F(6)=15;
meat(7) = 1;
F(7)=15;
meat(8)=1;
F(8)=15;
meat(9) = 1;
F(9)=15;
meat(10)=1;
F(10)=15;
meat(11) = 1;
F(11)=25;
meat(12)=1;
F(12)=25;
meat(13)=1;
F(13)=25;
meat(14)=1;
F(14)=25;
meat(15) = 1;
F(15)=25;
% meat(16)=1;
% F(16)=5;
% meat(17) = 1;
% F(17)=5;
% meat(18)=1;
% F(18)=5;
% meat(19) = 1;
% F(19)=5;
% meat(20)=1;
% F(20)=5;

for k=1:Nk

    %% SS Her starter du med  legge inn grensebetingelsene for i = 1
    %% frst. Jeg har kommentert vekk koden din p slutten og laget et nytt
    %% forslag som flger:

    %% Antagelsen her er at denne frste stripen fr tilfrt materiale fra
    %% utenfor ved beregningstidspunktet.
%     Q_vek1(Nk-k+1)=x(Nk-k+1);
%     Q_vek2(Nk-k+1)=x(2*Nk-k+1);
    q1=x(k);
    q2=x(Nk+k);
    isMeat(1) = meat(k);
    fat(1)    = meat(k)*F(k); 
    if (isMeat(1)==1) 
        ti = -18.0; 
    else
        ti = 0.0;
    end
    
    for j=1:Ny
        T(j,1)     = ti;
        Tnew (j,1) = T(j,1);
        Tarr(j,1,k)= T(j,1); % Dersom det kommer inn mer kjtt, m temperaturen settes ved x=1 for nvrende tidsskritt.
    end

    for i=2:Nx+1    %% SS endret simulering fra 2 til Nx. Fant ut at det var best mht grenseverdier. 
        %% SS Har generelt innfrt i-1 i varmetilfrsels og
        %% varmeledningsleddet.
        %% SS sjekker p forrige slice, hvorvidt det er kjtt der
        if (isMeat(i-1)==1)

            %Effekt fra oppvarming fra oversiden
            Q(i-1,1)=q1/o*uarr1(i-1,Nx) + q2/o*uarr2(i-1,Nx);   %% SS i -> i-1; ogs lenger nede
            for j=2:Ny-1
                Q(i-1,j) = Q(i-1,j-1)*exp(-dy/dp(T(j-1,i-1)));
                % SS Lagrer ny T i Tnew, s en ikke benytter oppdaterte T-er
                % som en gammel T
                Tnew(j,i) = T(j,i) - v*dk/dx*T(j,i) + v*dk/dx*T(j,i-1) + ...
                    r*ko(fat(i-1),T(j,i-1))/p/cp(fat(i-1),T(j,i-1))*(T(j+1,i-1)-2*T(j,i-1)+T(j-1,i-1)) + ...
                    dk*Q(i-1,j)/p/cp(fat(i-1),T(j,i-1));

            end

            %% SS Endret til Tnew
            Tnew(1,i)  = (Tnew(2,i) + T_a*dy*h/ko(fat(i-1),T(2,i-1)))/(1+dy*h/ko(fat(i-1),T(2,i-1)));
            Tnew(Ny,i) = Tnew(Ny-1,i);
            Q(i-1,Ny)    = Q(i-1,Ny-1)*exp(-dy/dp(T(Ny-1,i-1))); %Q(i,Ny) er gjort om til Q(i-1,Ny) Gjelder ogs lengre ned. Erlend

            %Effekt fra oppvarming fra undersiden
            Q_under(i-1,Ny) = Q(i-1,Ny);
            for j=Ny:-1:2
                Q_under(i-1,j-1) = Q_under(i-1,j)*exp(-dy/dp(T(j-1,i-1)));

                %% SS Tnew
                Tnew(j,i) = Tnew(j,i) +  dk*Q_under(i-1,j)/p/cp(fat(i-1),T(j,i-1));
            end

            %Undersidens effekt p overflaten:
            %% SS Tnew
            Tnew(1,i) = Tnew(1,i) + dk*Q_under(i-1,1)/p/cp(fat(i-1),T(j,i-1));

        %% SS Setter temp = null der det ikke er kjtt
        else
            for j=1:Ny
                Tnew(j,i) = 0.0;
            end
        end
        isMeatNew(i) = isMeat(i-1);
        fatNew(i)    = fat(i-1);
    end
    
    
    
    Tarr(:,:,k+1)   =   Tnew;
    T               =   Tnew;
    fat             =   fatNew;
    isMeat          =   isMeatNew;   
end

close all
t=1:1:Nk+1;

temp=-18*ones(1,Nk);
temp2=18*ones(1,Nk);
temp3=-18*ones(1,Nk);
temp4=-18*ones(1,Nk);
temp5=-18*ones(1,Nk);
temp6=-18*ones(1,Nk);
temp7=-18*ones(1,Nk);

for i=1:length(t)
    
    %% Frste blokk
    if i<=Nx+1
        temp(i)=Tarr(1,i,i);
        temp2(i)=Tarr(2,i,i);        
        temp3(i)=Tarr(4,i,i);
        temp4(i)=Tarr(6,i,i);
        temp5(i)=Tarr(7,i,i);
    else
        temp(i)=temp(i-1);
        temp2(i)=temp2(i-1);
        temp3(i)=temp3(i-1);
        temp4(i)=temp4(i-1);
        temp5(i)=temp5(i-1);
%     end
% %     temp7(i)=Tarr(7,i,i);
% %     temp2(i)=Tarr(2,i,i);
%     if i>=2 && i<=Nx+2
%         temp3(i)=Tarr(1,i-1,i);
%     elseif i>=2
%         temp3(i) = temp3(i-1);
%     end
%     if i>=3 && i<=Nx+3
%         temp4(i)=Tarr(1,i-2,i);
%     elseif i>=3
%         temp4(i)=temp4(i-1);
%     end
%     if i>=4 && i<=Nx+4
%         temp5(i)=Tarr(1,i-3,i);
%     elseif i>=4
%         temp5(i)=temp5(i-1);
%     end
%     if i>=5 && i<=Nx+5
%         temp6(i)=Tarr(1,i-4,i);
%     elseif i>=5
%         temp6(i)=temp6(i-1);
    end
    %% Andre blokk
%     if i>=6 && i<=Nx+6
%         temp(i)=Tarr(1,i-5,i);
%     elseif i>=2
%         temp(i) = temp(i-1);
%     end
%     if i>=7 && i<=Nx+7
%         temp3(i)=Tarr(1,i-6,i);
%     elseif i>=3
%         temp3(i)=temp3(i-1);
%     end
%     if i>=8 && i<=Nx+8
%         temp4(i)=Tarr(1,i-7,i);
%     elseif i>=4
%         temp4(i)=temp4(i-1);
%     end
%     if i>=9 && i<=Nx+9
%         temp5(i)=Tarr(1,i-8,i);
%     elseif i>=5
%         temp5(i)=temp5(i-1);
%     end
%     if i>=10 && i<=Nx+10
%         temp6(i)=Tarr(1,i-9,i);
%     elseif i>=5
%         temp6(i)=temp6(i-1);
%     end


    %% Tredje blokk
%     if i>=11 && i<=Nx+11
%         temp(i)=Tarr(1,i-10,i);
%     elseif i>=2
%         temp(i) = temp(i-1);
%     end
%     if i>=12 && i<=Nx+12
%         temp3(i)=Tarr(1,i-11,i);
%     elseif i>=3
%         temp3(i)=temp3(i-1);
%     end
%     if i>=13 && i<=Nx+13
%         temp4(i)=Tarr(1,i-12,i);
%     elseif i>=4
%         temp4(i)=temp4(i-1);
%     end
%     if i>=14 && i<=Nx+14
%         temp5(i)=Tarr(1,i-13,i);
%     elseif i>=5
%         temp5(i)=temp5(i-1);
%     end
%     if i>=15 && i<=Nx+15
%         temp6(i)=Tarr(1,i-14,i);
%     elseif i>=5
%         temp6(i)=temp6(i-1);
%     end
end


plot(temp)
hold on
% plot(temp2,'c')
plot(temp3,'r')
plot(temp4,'g')
plot(temp5,'y')
plot(temp6,'c')
% plot(temp7,'r')

xlabel('Tidsskritt [15 sek]')
ylabel('Temperatur [Celsius]')
% legend('Overflate','Bunn')
% legend('1. blokk, 5% fett','2. blokk, 15% fett','3. blokk, 5% fett')%,'Slice 4','Slice 5')
legend('Slice 1','Slice 2','Slice 3','Slice 4','Slice 5');
grid
