
N=95;
l=0.5;
o=l*0.36; % Overflateareal til kjttblokkene

dy=0.01; %
Ny=round(0.07/dy); % antall dybdesteg

dx=0.1;
Nx=round(2/dx); % antall breddesteg

v=0.4/60;

dk=dx/v; % tidsteg [sek/steg]
Nk=300/dk + N  ; % antall tidssteg


Tarr  =  zeros(Ny,Nx+1,Nk+1); % lager temperatur matrise
T     =  zeros(Ny,Nx+1);
TarrP  =  zeros(Ny,Nx+1,Nk+1); % lager temperatur matrise
TP     =  zeros(Ny,Nx+1);

%% SS Definerer Tny for  lagre ny T i
Tnew = zeros(Ny,Nx+1);
TnewP = zeros(Ny,Nx+1);

T_a  = 10; % omgivelses temperatur

isMeat    = zeros(1,Nx+1);
meat      = zeros(1,Nk+1);
isMeatNew = zeros(1,Nx+1);   %% SS Ny variabel
fatNew    = zeros(1,Nx+1);   %% SS Ny variabel

Q=zeros(Nx,Ny); % energi matrise
Q_under=zeros(Nx,Ny);
% q1=1/2;
% q2=1/2;

r=dk/dy^2;

F=zeros(1,Nk+1); % fettprosent i kjttet
fat=zeros(1,Nx+1);



p=1057; % tetthet kg/m^3

h=5; % varmeovergangstall mellom kjtt og luft W/m^2K

e=0;
%% Modell med antatte parametre:

for i =1:N+1
    meat(i)=1;
    F(i)=5;
end






for k=1:Nk

    %% SS Her starter du med  legge inn grensebetingelsene for i = 1
    %% frst. Jeg har kommentert vekk koden din p slutten og laget et nytt
    %% forslag som flger:

    %% Antagelsen her er at denne frste stripen fr tilfrt materiale fra
    %% utenfor ved beregningstidspunktet.
%     Q_vek1(Nk-k+1)=x(Nk-k+1);
%     Q_vek2(Nk-k+1)=x(2*Nk-k+1);
    q1=x(k);
    q2=x(Nk+k);
    isMeat(1) = meat(k);
    fat(1)    = meat(k)*F(k); 
    if (isMeat(1)==1) 
        ti = -18.0; 
    else
        ti = 0.0;
    end
    
    for j=1:Ny
        T(j,1)     = ti;
        Tnew (j,1) = T(j,1);
        Tarr(j,1,k)= T(j,1); % Dersom det kommer inn mer kjtt, m temperaturen settes ved x=1 for nvrende tidsskritt.
    end

    for i=2:Nx+1    %% SS endret simulering fra 2 til Nx. Fant ut at det var best mht grenseverdier. 
        %% SS Har generelt innfrt i-1 i varmetilfrsels og
        %% varmeledningsleddet.
        %% SS sjekker p forrige slice, hvorvidt det er kjtt der
        if (isMeat(i-1)==1)

            %Effekt fra oppvarming fra oversiden
            Q(i-1,1)=q1/o*uarr1(i-1,Nx) + q2/o*uarr2(i-1,Nx);   %% SS i -> i-1; ogs lenger nede
            for j=2:Ny-1
                Q(i-1,j) = Q(i-1,j-1)*exp(-dy/dp(T(j-1,i-1)));
                % SS Lagrer ny T i Tnew, s en ikke benytter oppdaterte T-er
                % som en gammel T
                Tnew(j,i) = T(j,i) - v*dk/dx*T(j,i) + v*dk/dx*T(j,i-1) + ...
                    r*ko(fat(i-1),T(j,i-1))/p/cp(fat(i-1),T(j,i-1))*(T(j+1,i-1)-2*T(j,i-1)+T(j-1,i-1)) + ...
                    dk*Q(i-1,j)/p/cp(fat(i-1),T(j,i-1));

            end

            %% SS Endret til Tnew
            Tnew(1,i)  = (Tnew(2,i) + T_a*dy*h/ko(fat(i-1),T(2,i-1)))/(1+dy*h/ko(fat(i-1),T(2,i-1)));
            Tnew(Ny,i) = Tnew(Ny-1,i);
            Q(i-1,Ny)    = Q(i-1,Ny-1)*exp(-dy/dp(T(Ny-1,i-1))); %Q(i,Ny) er gjort om til Q(i-1,Ny) Gjelder ogs lengre ned. Erlend

            %Effekt fra oppvarming fra undersiden
            Q_under(i-1,Ny) = Q(i-1,Ny);
            for j=Ny:-1:2
                Q_under(i-1,j-1) = Q_under(i-1,j)*exp(-dy/dp(T(j-1,i-1)));

                %% SS Tnew
                Tnew(j,i) = Tnew(j,i) +  dk*Q_under(i-1,j)/p/cp(fat(i-1),T(j,i-1));
            end

            %Undersidens effekt p overflaten:
            %% SS Tnew
            Tnew(1,i) = Tnew(1,i) + dk*Q_under(i-1,1)/p/cp(fat(i-1),T(j,i-1));

        %% SS Setter temp = null der det ikke er kjtt
        else
            for j=1:Ny
                Tnew(j,i) = 0.0;
            end
        end
        isMeatNew(i) = isMeat(i-1);
        fatNew(i)    = fat(i-1);
    end
    
    
    
    Tarr(:,:,k+1)   =   Tnew;
    T               =   Tnew;
    fat             =   fatNew;
    isMeat          =   isMeatNew;   
end



%% Prosess med usikre parametre

isMeat    = zeros(1,Nx+1);
meat      = zeros(1,Nk+1);
isMeatNew = zeros(1,Nx+1);   
fatNew    = zeros(1,Nx+1);   

for i =1:N+1
    meat(i)=1;
    F(i)=25;
end
% meat(1) = 1;

anal=zeros(Nx+1,1);

dangel1=zeros(1,N+1);
dangel2=zeros(1,N+1);
paa=zeros(1,15);
just=ones(1,Nk+1);

for k=1:Nk

    %% SS Her starter du med  legge inn grensebetingelsene for i = 1
    %% frst. Jeg har kommentert vekk koden din p slutten og laget et nytt
    %% forslag som flger:

    %% Antagelsen her er at denne frste stripen fr tilfrt materiale fra
    %% utenfor ved beregningstidspunktet.
    Q_vek1(Nk-k+1)=x(Nk-k+1);
    Q_vek2(Nk-k+1)=x(2*Nk-k+1);
    if(just(k)~=1)
%         q1= x(k) + x(k)*just(k)*5;    % Frste Regulator 
        q1 = x(k);
        q2 = x(Nk+k) + x(Nk+k)*just(k)/3;
        dangel1(k)=q1;
        dangel2(k)=q2;

%         q1= x(k)*just(k);
%         q2= x(Nk+k)*just(k);

        if(q1>1)
            q1=1;
        elseif(q1<0)
            q1=0;
        end
        if(q2>1)
            q2=1;        
        elseif(q2<0)
            q2=0;
        end
    else
        q1= x(k) ;
        q2= x(Nk+k) ;
    end
    
    isMeat(1) = meat(k);
    fat(1)    = meat(k)*F(k); 
    if (isMeat(1)==1) 
        ti = -18.0; 
    else
        ti = 0.0;
    end
    
    for j=1:Ny
        TP(j,1)     = ti;
        TnewP (j,1) = TP(j,1);
        TarrP(j,1,k)= TP(j,1); % Dersom det kommer inn mer kjtt, m temperaturen settes ved x=1 for nvrende tidsskritt.
    end

    for i=2:Nx+1    %% SS endret simulering fra 2 til Nx. Fant ut at det var best mht grenseverdier. 
        %% SS Har generelt innfrt i-1 i varmetilfrsels og
        %% varmeledningsleddet.
        %% SS sjekker p forrige slice, hvorvidt det er kjtt der
        if (isMeat(i-1)==1)

            %Effekt fra oppvarming fra oversiden
            Q(i-1,1)=q1/o*uarr1(i-1,Nx) + q2/o*uarr2(i-1,Nx);   %% SS i -> i-1; ogs lenger nede
            for j=2:Ny-1
                Q(i-1,j) = Q(i-1,j-1)*exp(-dy/dp(TP(j-1,i-1)));
                % SS Lagrer ny T i Tnew, s en ikke benytter oppdaterte T-er
                % som en gammel T
                TnewP(j,i) = TP(j,i) - v*dk/dx*TP(j,i) + v*dk/dx*TP(j,i-1) + ...
                    r*ko(fat(i-1),TP(j,i-1))/p/cp(fat(i-1),TP(j,i-1))*(TP(j+1,i-1)-2*TP(j,i-1)+TP(j-1,i-1)) + ...
                    dk*Q(i-1,j)/p/cp(fat(i-1),TP(j,i-1));

            end

            %% SS Endret til Tnew
            TnewP(1,i)  = (TnewP(2,i) + T_a*dy*h/ko(fat(i-1),TP(2,i-1)))/(1+dy*h/ko(fat(i-1),TP(2,i-1)));
            TnewP(Ny,i) = TnewP(Ny-1,i);
            Q(i-1,Ny)    = Q(i-1,Ny-1)*exp(-dy/dp(TP(Ny-1,i-1))); %Q(i,Ny) er gjort om til Q(i-1,Ny) Gjelder ogs lengre ned. Erlend

            %Effekt fra oppvarming fra undersiden
            Q_under(i-1,Ny) = Q(i-1,Ny);
            for j=Ny:-1:2
                Q_under(i-1,j-1) = Q_under(i-1,j)*exp(-dy/dp(TP(j-1,i-1)));

                %% SS Tnew
                TnewP(j,i) = TnewP(j,i) +  dk*Q_under(i-1,j)/p/cp(fat(i-1),TP(j,i-1));
            end

            %Undersidens effekt p overflaten:
            %% SS Tnew
            TnewP(1,i) = TnewP(1,i) + dk*Q_under(i-1,1)/p/cp(fat(i-1),TP(j,i-1));

        %% SS Setter temp = null der det ikke er kjtt
        else
            for j=1:Ny
                TnewP(j,i) = 0.0;
            end
        end
        isMeatNew(i) = isMeat(i-1);
        fatNew(i)    = fat(i-1);
    end
    
    
    
    TarrP(:,:,k+1)   =   TnewP;
    TP               =   TnewP;
    fat             =   fatNew;
    isMeat          =   isMeatNew;
    anal(k)=TarrP(1,21,k);
    

%      if(TarrP(1,Nx+1,k+1)~=Tarr(1,Nx+1,k+1))
%         if Tarr(1,Nx+1,k+1)<TarrP(1,Nx+1,k+1);
%             just(k+1) = just(k) + (TarrP(1,Nx+1,k+1) - Tarr(1,Nx+1,k+1));
%         else
%             just(k+1) = (Tarr(1,Nx+1,k+1) - TarrP(1,Nx+1,k+1));
%         end 
%     end

%% Frste regulator
    if (k==21)||(k==36)||(k==51)||(k==66)||(k==81)||(k==96)
        if(TarrP(1,Nx+1,k+1)~=Tarr(1,Nx+1,k+1))
           e = e + Tarr(1,Nx+1,k+1) - TarrP(1,Nx+1,k+1);
           
           for t=1:15
               just(k+t) =  e;
               
           end
           
        end
    end
end



close all
t=1:1:Nk+1;

temp=-18*ones(1,Nk);
temp2=18*ones(1,Nk);
temp3=-18*ones(1,Nk);
temp4=-18*ones(1,Nk);
temp5=-18*ones(1,Nk);
temp6=-18*ones(1,Nk);
temp7=-18*ones(1,Nk);
temp8=-18*ones(1,Nk);
temp9=-18*ones(1,Nk);
temp10=-18*ones(1,Nk);

for i=1:length(t)
    
    %% Frste blokk
%     if i<=Nx+1
% %         temp(i)=Tarr(1,i,i);
% %         temp2(i)=Tarr(2,i,i);        
% %         temp3(i)=Tarr(4,i,i);
% %         temp4(i)=Tarr(6,i,i);
% %         temp5(i)=Tarr(7,i,i);
% 
%         temp(i)=TarrP(1,i,i);
% %         temp2(i)=TarrP(2,i,i);        
% %         temp3(i)=TarrP(4,i,i);
% %         temp4(i)=TarrP(6,i,i);
% %         temp5(i)=TarrP(7,i,i);
%     else
%         temp(i)=temp(i-1);
% %         temp2(i)=temp2(i-1);
% %         temp3(i)=temp3(i-1);
% %         temp4(i)=temp4(i-1);
% %         temp5(i)=temp5(i-1);
%     end
% % %     temp7(i)=Tarr(7,i,i);
% % %     temp2(i)=Tarr(2,i,i);
%     if i>=2 && i<=Nx+2
%         temp3(i)=TarrP(1,i-1,i);
%     elseif i>=2
%         temp3(i) = temp3(i-1);
%     end
%     if i>=3 && i<=Nx+3
%         temp4(i)=TarrP(1,i-2,i);
%     elseif i>=3
%         temp4(i)=temp4(i-1);
%     end
%     if i>=4 && i<=Nx+4
%         temp5(i)=TarrP(1,i-3,i);
%     elseif i>=4
%         temp5(i)=temp5(i-1);
%     end
%     if i>=5 && i<=Nx+5
%         temp6(i)=TarrP(1,i-4,i);
%     elseif i>=5
%         temp6(i)=temp6(i-1);
%     end
%     if i>=6 && i<=Nx+6
%         temp7(i)=TarrP(1,i-5,i);
%     elseif i>=6
%         temp7(i)=temp8(i-1);
%     end
%     if i>=36 && i<=Nx+36
%         temp8(i)=TarrP(1,i-35,i);
%     elseif i>=7
%         temp8(i)=temp8(i-1);
%     end
%     if i>=40 && i<=Nx+40
%         temp9(i)=TarrP(1,i-39,i);
%     elseif i>=6
%         temp9(i)=temp9(i-1);
%     end
%     if i>=79 && i<=Nx+79
%         temp10(i)=TarrP(1,i-78,i);
%     elseif i>=7
%         temp10(i)=temp10(i-1);
%     end
    %% Andre blokk
%     if i>=6 && i<=Nx+6
%         temp(i)=Tarr(1,i-5,i);
%     elseif i>=2
%         temp(i) = temp(i-1);
%     end
%     if i>=7 && i<=Nx+7
%         temp3(i)=Tarr(1,i-6,i);
%     elseif i>=3
%         temp3(i)=temp3(i-1);
%     end
%     if i>=8 && i<=Nx+8
%         temp4(i)=Tarr(1,i-7,i);
%     elseif i>=4
%         temp4(i)=temp4(i-1);
%     end
%     if i>=9 && i<=Nx+9
%         temp5(i)=Tarr(1,i-8,i);
%     elseif i>=5
%         temp5(i)=temp5(i-1);
%     end
%     if i>=10 && i<=Nx+10
%         temp6(i)=Tarr(1,i-9,i);
%     elseif i>=5
%         temp6(i)=temp6(i-1);
%     end


    %% Tredje blokk
%     if i>=11 && i<=Nx+11
%         temp(i)=Tarr(1,i-10,i);
%     elseif i>=2
%         temp(i) = temp(i-1);
%     end
%     if i>=12 && i<=Nx+12
%         temp3(i)=Tarr(1,i-11,i);
%     elseif i>=3
%         temp3(i)=temp3(i-1);
%     end
%     if i>=13 && i<=Nx+13
%         temp4(i)=Tarr(1,i-12,i);
%     elseif i>=4
%         temp4(i)=temp4(i-1);
%     end
%     if i>=14 && i<=Nx+14
%         temp5(i)=Tarr(1,i-13,i);
%     elseif i>=5
%         temp5(i)=temp5(i-1);
%     end
%     if i>=15 && i<=Nx+15
%         temp6(i)=Tarr(1,i-14,i);
%     elseif i>=5
%         temp6(i)=temp6(i-1);
%     end
end


% plot(temp)
hold on
% % plot(temp2,'c')
% plot(temp3,'r')
% plot(temp4,'g')
% plot(temp5,'y')
% plot(temp6,'c')
% plot(temp7,'m')
% plot(temp8,'k')
% plot(temp9,'r')
% plot(temp10,'g')

% xlabel('Tidsskritt [15 sek]')
% ylabel('Temperatur [Celsius]')
% legend('Overflate','Bunn')
% legend('1. blokk, 5% fett','2. blokk, 15% fett','3. blokk, 5% fett')%,'Slice 4','Slice 5')
% legend('Slice 15','Slice 20','Slice 59','Slice 4','Slice 5','Slice 6','Slice 7','Slice 8','Slice 9');
grid

t=zeros(1,(20+N)*2);
u1=zeros(1,(20+N)*2);
u2=zeros(1,(20+N)*2);


% for i=1:1:length(t)
%     if mod(i,2) == 0
%        t(i) = t(i-1) + 1;
%     else
%         if i == 1
%            t(i) = 0;
%         else
%            t(i) = t(i-1);
%         end
%     end
%     if mod(i,2) == 0       
%        u1(i) = dangel1((i/2));
%        u2(i) = dangel2((i/2));          
%     else
%        u1(i) = dangel1((i+1)/2);
%        u2(i) = dangel2((i+1)/2);
%     end   
% %     u3(i)=u1(i)+u2(i);
% end
% plot(t,u1)
% hold on
% plot(t,u2,'r')
% xlabel('Tidsskritt [15 sek]')
% ylabel('Temperatur [Celsius]')
% legend('u1','u2')
